﻿using System.Threading.Tasks;
using Buddy.Coroutines;
using Clio.Utilities;
using ff14bot;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Objects;
using ff14bot.RemoteWindows;
using RetBot.Settings;

namespace RetBot
{
    public class RetainerRetask
    {
        //Variables / Declarations
        private static GameObject _summonbell;
        public static int LoopCount;
        private RetBot_Form _form;
        public static RetBotSettings settings = RetBotSettings.instance;        

        public static async Task Retask()
        {
            LoopCount = 1;
            var location = new Vector3(36.32549f, 28.99997f, -762.0803f);            
            _summonbell = GameObjectManager.GetObjectByObjectId(4627756);
            await Coroutine.Wait(1000, () => Core.Player.Distance(location) > 3);

            while (LoopCount != 0)
            {
            RetaskF:
                #region Retainer Selection
                //Open retainer list               
                Logging.Write("[Retbot] Using Summoning Bell.");
                _summonbell.Interact();

                //Select A Retainer
                Logging.Write("[Retbot] Searching for Complete Ventures.");
                await Coroutine.Wait(3000, () => SelectString.IsOpen);               
                    {
                        if (SelectString.ClickLineContains(settings.Lan_Complete))
                        {
                            Logging.Write("[Retbot] Selecting first available Retainer.");
                            SelectString.ClickLineContains(settings.Lan_Complete);
                        }
                        else
                        {
                            Logging.Write("[Retbot] No Ventures available, Quitting Retainer Menu.");
                            SelectString.ClickLineContains(settings.Lan_Quit);
                            LoopCount = 0;
                            return;
                        }
                    }

                //Skip dialog
                await Coroutine.Wait(3000, () => Talk.DialogOpen);
                Talk.Next();
                #endregion 

                //View Venture Report
                Logging.Write("[Retbot] Selecting Venture Report.");
                await Coroutine.Wait(3000, () => SelectString.IsOpen);
                SelectString.ClickSlot(5);

                //Venture Report Window Reassign/Confirm
                Logging.Write("[Retbot] Reassigning Venture.");
                await Coroutine.Wait(3000, () => RetainerTaskResult.IsOpen);
                RetainerTaskResult.Reassign();

                //Venture Confirm Window
                Logging.Write("[Retbot] Confirming Reassignment.");
                await Coroutine.Wait(3000, () => RetainerTaskAsk.IsOpen);
                RetainerTaskAsk.Confirm();

                //Wait/Skip dialog
                await Coroutine.Wait(3000, () => Talk.DialogOpen);
                Talk.Next();

                //Quit Retainer Dialog
                Logging.Write("[Retbot] Quitting Selected Retainer.");
                await Coroutine.Wait(3000, () => SelectString.IsOpen);
                SelectString.ClickSlot(10);

                //Wait/Skip dialog
                await Coroutine.Wait(3000, () => Talk.DialogOpen);
                Talk.Next();

                //None of the Retainers are back/ready
                Logging.Write("[Retbot] Quitting Retainer Menu.");
                SelectString.ClickLineContains(settings.Lan_Quit);

                Logging.Write("[Retbot] Returning to beginning of the Retask Loop.");
                await Coroutine.Sleep(3000);
                {goto RetaskF;}
            }
            
            Logging.Write("[Retbot] All avilable ventures ordered!");
            LoopCount = 0;
        }
    }
}
